# For tracer configuration
ENV_APPDYNAMICS_CONTROLLER_HOST = 'APPDYNAMICS_CONTROLLER_HOST'
ENV_APPDYNAMICS_CONTROLLER_PORT = 'APPDYNAMICS_CONTROLLER_PORT'
ENV_APPDYNAMICS_AGENT_ACCOUNT_ACCESS_KEY = 'APPDYNAMICS_AGENT_ACCOUNT_ACCESS_KEY'
ENV_APPDYNAMICS_ACCOUNT_NAME = 'APPDYNAMICS_ACCOUNT_NAME'
ENV_APPDYNAMICS_APPLICATION_NAME = 'APPDYNAMICS_APPLICATION_NAME'
ENV_APPDYNAMICS_TIER_NAME = 'APPDYNAMICS_TIER_NAME'
ENV_SERVERLESS_API_ENDPOINT = 'APPDYNAMICS_SERVERLESS_API_ENDPOINT'
ENV_APPDYNAMICS_EVENTS_FLUSH_PERIOD_MS = 'APPDYNAMICS_EVENTS_FLUSH_PERIOD_MS'
ENV_LOG_LEVEL = 'APPDYNAMICS_LOG_LEVEL'
ENV_APPDYNAMICS_ENABLE_EUM = 'APPDYNAMICS_ENABLE_EUM'
ENV_APPDYNAMICS_EUM_AJAX = 'APPDYNAMICS_EUM_AJAX'
ENV_APPDYNAMICS_DISABLE_AGENT = 'APPDYNAMICS_DISABLE_AGENT'
ENV_APPDYNAMICS_HTTP_TIMEOUT_MS = 'APPDYNAMICS_HTTP_TIMEOUT_MS' # used to specify max timeout when tracer sends requests to the pipeline.

# Agent Config
AGENT_CONFIG_RETRY_TIMEOUT_SECS = 60
AGENT_CONFIG_INITIAL_RETRY_TIMEOUT_SECS = 10
AGENT_CONFIG_INITIAL_FAILURE_TIMEOUT_SECS = 60
EVENT_TYPE_AGENT_CONFIG = "AGENT_CONFIG"

# Headers
X_APPD_API_KEY_HEADER = "x-api-key"
X_APPD_REQUEST_TYPE_HEADER = "x-appd-request-type"
X_APPD_ROUTING_KEY_HEADER = "x-appd-routing-key"

DEFAULT_AGENT_VERSION = '0.0.1'
DEFAULT_SERVERLESS_API_ENDPOINT_VERSION = 'v1'
DEFAULT_CONFIG_URL_PATH = 'agentconfig'
DEFAULT_EVENT_URL_PATH = 'events'
TRACER_LANGUAGE_NAME = "python"

# Event Service
FLUSH_REFRESH_TIME_IN_MS = 5000

# Logger
APPDYNAMICS_LOGGER_NAME = "appdynamics_tracer"

# Transaction
ENTRY_POINT_TYPE = "PYTHON_WEB"
OVERFLOW_TRANSACTION_NAME = "_APPDYNAMICS_DEFAULT_TX_"

# HTTP Service
HTTP_DEFAULT_TIMEOUT_MS = 2000 # default value for ENV_APPDYNAMICS_HTTP_TIMEOUT_MS if not provided.

# HTTP Proxy
HTTP_PROXY_HOST = "APPDYNAMICS_HTTP_PROXY_HOST"
HTTP_PROXY_PORT = "APPDYNAMICS_HTTP_PROXY_PORT"
HTTP_PROXY_SERVER_CERTIFICATE_PATH = "APPDYNAMICS_HTTP_PROXY_SERVER_CERTIFICATE"
HTTP_PROXY_USER = "APPDYNAMICS_HTTP_PROXY_USER"
HTTP_PROXY_PASSWORD = "APPDYNAMICS_HTTP_PROXY_PASSWORD"
HTTP_PROXY_PASSWORD_FILE = "APPDYNAMICS_HTTP_PROXY_PASSWORD_FILE"

# Correlation Header
CONTROLLER_GUID = "ctrlguid"
ACCOUNT_GUID = "acctguid"
APP_ID = "appId"
BT_ID = "btid"
REQUEST_GUID = "guid"
TIMESTAMP = "ts"
UNRESOLVED_EXIT_ID = "unresolvedexitid"
COMPONENT_ID_FROM = "cidfrom"
COMPONENT_ID_TO = "cidto"
EXIT_CALL_TYPE_ORDER = "etypeorder"
EXIT_CALL_SUBTYPE_KEY = "esubtype"
EXIT_POINT_GUID = "exitguid"
THREAD_CALL_CHAIN_FOR_OUT_OF_PROCESS = "tcop"
DONOTRESOLVE = "donotresolve"
SNAPSHOT_ENABLE = "snapenable"
DISABLE_TRANSACTION_DETECTION = "notxdetect"
FORCE_HOTSPOT_COLLECT = "hotspotenable"
HOTSPOT_COLLECTING_CPU_TIME = "hotspotcpu"
DEV_MODE_ENABLED = "devmodeenabled"
ASYNC_CALL = "async"
DEBUG_ENABLED = "debug"
MAX_METRIC_LENGTH = 750
METRIC_NAME_LENGTH = 16 + 15 + 20
APPDYNAMICS_TRANSACTION_CORRELATION_HEADER_KEY = "singularityheader"

# EUM
CLIENT_REQUEST_GUID_KEY = {"long": "clientRequestGuid", "short": "g"}
BT_ID_KEY = {"long": "btId", "short": "i"}
BT_DURATION_KEY = {"long": "btDuration", "short": "d"}
GLOBAL_ACCOUNT_NAME_KEY = {"long": "globalAccountName", "short": "n"}
ADRUM_PREFIX = "ADRUM_"
ADRUM_MASTER_COOKIE_NAME = "ADRUM_BT"
EUM_COOKIE_EXPIRATION_DURATION = 30000